<?php


namespace Easymailing\App\Api;


class Hydrator
{
	public function hydrate($responseBody)
	{
		if($responseBody['@type'] === "hydra:Collection"){
			$contextData = explode("/", $responseBody['@context']);
			return $this->hydrateCollection($responseBody, end($contextData));
		}

		return $this->hydrateObject($responseBody, $responseBody['@type']);

	}

	private function hydrateObject($responseBody, $className)
	{
		$class = "Easymailing\\App\\Model\\".$className;
		$object = new $class();

		$object->id = $responseBody['@id'];
		foreach(array_keys($responseBody) as $key) {
			$property = $this->camelize($key);
			if(property_exists($class, $property)){
				$object->$property = $responseBody[$key];
			}
		}
		return $object;
	}

	private function hydrateCollection($responseBody, $className)
	{
		$array = [];
		foreach($responseBody['hydra:member'] as $data) {
			$array[] = $this->hydrateObject($data, $className);
		}
		return $array;
	}

	function camelize($input, $separator = '_')
	{
		return lcfirst(str_replace($separator, '', ucwords($input, $separator)));
	}

}
