<?php


namespace Easymailing\App\Core\Provider;


use Easymailing\App\Core\Session\FlashBag;
use Easymailing\App\Core\Templating\Templating;

class SessionProvider implements ProviderInterface
{
	private $application;

	public function __construct(\Easymailing\App\Core\Application $application)
	{
		$this->application = $application;
	}

	public function register()
	{
		add_action('init', [$this, 'registerSession']);
	}


	public function registerSession() {
		if(!session_id()) {
			session_start();
		}

		$container = $this->application->getContainer();

		$flashBag = new FlashBag();

		$container['flashbag'] = function($c) use ($flashBag) {
			return $flashBag;
		};


	}
}
